



require 'imbir5'
floor = math.floor
random = math.random
abs = math.abs
sin,cos = math.sin, math.cos
min,max = math.min,math.max
PI = math.pi
getmetatable('').__index = function(s,i) return string.sub(s,i,i) end

math.randomseed(os.time())


function rndsgn(x)
	if random(2) == 1 then
		return -x
	else
		return x
	end
end


function Reset(Score,Lifes)
	X = World()
	ROCKS = {maxv = 6, split = 2, maxn = 7}
	ROCKS.n = ROCKS.maxn
	SCORE = Score or 0
	
	LIFES = {}
	Lifes = Lifes or 3
	for lifes = 1,Lifes do
		local I = Imbir{
			position = {x = lifes*10, y = 10},
			radius = 5,
			rotation = 0,
			shipDraw = true
			}
		table.insert(LIFES,I)
		X = X + I
	end
	FPS = 60
	
	
	ship = Imbir{
		position = {x = 400, y = 300},
		radius = 10,
		deltap = {x=0,y=0},
		velocity = {x=0,y=0},
		rotation = 0,
		deltar = 0,
		collidable = true,
		pellet = 0,
		shipDraw = true,
		ship = true,
		input = true,
		invincibility = 300,
		}
	
	X = X + ship
	
	for i=1,ROCKS.maxn do
		I = Imbir{ 
			rotation = 0,
			radius = 10 + random(30),
			deltap = {x=0,y=0},
			deltar = rndsgn(random()*0.1),
			rock = true,
			velocity = {x = rndsgn(random()), y = rndsgn(random())},
			collidable = true,
			vert = 2+random(ROCKS.maxv)
			}
		
		local x,y 
		repeat
			x,y = random(800), random(600)
		until abs(x-400) > 200 and abs(y-300) > 200
		
		I.position = {x=x,y=y}
		X = X+I
	end
end

Reset()

function clamp(a,b,x)
	if x < a then
		return a
	elseif x > b then
		return b
	end
	return x
end
function collides(x1,y1,r1, x2,y2,r2)
	return abs(x1-x2) - r1 - r2 <= 0  and  abs(y1-y2) - r1 - r2 <= 0
end



System{
	_name = 'draw',
	
	'position',
	'rotation',
	'radius',
	
	Logic = function(a)
		if a.rock then
			local V = {}
			local angle = 1 / a.vert
			for i=1,a.vert do
				table.insert(V, a.position.x + a.radius*cos(2*PI*angle*i + a.rotation))
				table.insert(V, a.position.y + a.radius*sin(2*PI*angle*i + a.rotation))
			end
				
			if a.color == 'red' then
				love.graphics.setColor( 255,0,0 )
			elseif a.color == 'green' then
				love.graphics.setColor( 0,255,0 )
			end
			love.graphics.polygon('fill',V)
			love.graphics.setColor( 255,255,255 )
		elseif a.shipDraw  then
			if a.ship and (a.invincibility > 300 or a.invincibility % 2 == 0) then return end
			local roti = (PI*2)/3
			local a1,a2,a3 = a.rotation, a.rotation+roti, a.rotation+roti*2
			love.graphics.polygon('line',
				a.position.x + a.radius*cos(a1),  a.position.y + a.radius*sin(a1),
				a.position.x + a.radius*cos(a2),  a.position.y + a.radius*sin(a2),
				a.position.x, a.position.y,
				a.position.x + a.radius*cos(a3),  a.position.y + a.radius*sin(a3))
		elseif a.bullet or a.particle then
			love.graphics.line(a.position.x,a.position.y,
				a.position.x + a.radius*cos(a.rotation), a.position.y + a.radius*sin(a.rotation))
		end
	end
	}
System{
	_name = 'buildRockCollisionTable',
	
	'deltap',
	'collidable',
	'radius',
	'position',
	'rock',
	
	Logic = function(a)
		table.insert(COL,a)
		a.color = nil
	end
	}
	
System{
	_name = 'checkForEmptyTable',
	
	'ship',
	
	Logic = function(a)
		if #COL == 0 then
			SYSTEMS = WIN
			DRAW = DRAW_WIN
			a.win = true
			a.countdown = 200
		end
	end
	}
System{
	_name = 'applyVelocity',
	
	'deltap',
	'velocity',
	
	Logic = function(a)
		a.deltap = {x = a.velocity.x, y = a.velocity.y}
	end
	}
System{
	_name = 'checkForBulletCollisions',
	
	'deltap',
	'collidable',
	'radius',
	'position',
	'bullet',
	
	Logic = function(a)
		for i,b in ipairs(COL) do
			local rad2 = math.pow(a.radius + b.radius,2)
			local dist2 = math.pow(abs(a.position.x-b.position.x),2) + 
							math.pow(abs(a.position.y-b.position.y),2)
			
			if dist2 < rad2 then
				for i=1,8 do
					local rot = random()*2*PI
					X = X + Imbir{
						position = {x = b.position.x, y = b.position.y},
						radius = 4,
						deltap = {x=0,y=0},
						velocity = {x=(5+random(10)) * cos(rot),
									y=(5+random(10)) * sin(rot)},
						rotation = rot,
						particle = true,
						countdown = 5,
					}
				end
				
				if b.vert > 3 then
					b.vert = b.vert-1
					for i=1,2 do
						X = X + Imbir{
							position = {x = b.position.x, y = b.position.y},
							rotation = 0,
							radius = max(8,b.radius-3),
							deltap = {x=0,y=0},
							deltar = rndsgn(random()*0.1),
							rock = true,
							velocity = {x = rndsgn(random()), y = rndsgn(random())},
							collidable = true,
							vert = b.vert
							}
					end
				end
				
				X = X - b
				X = X-a
				SCORE = SCORE + 150*b.vert
				
				a.parent.pellet = a.parent.pellet-1
				break
			end
		end
	end
	}
System{
	_name = 'checkForShipCollisions',
	
	'deltap',
	'collidable',
	'radius',
	'position',
	'ship',
	
	Logic = function(a)
		if a.invincibility >= 0 then
			a.invincibility = a.invincibility-1
			return
		end
		
		for i,b in ipairs(COL) do
			local rad2 = math.pow(a.radius + b.radius,2)
			local dist2 = math.pow(abs(a.position.x-b.position.x),2) + 
							math.pow(abs(a.position.y-b.position.y),2)
			
			if dist2 < rad2 then
				
				for i=1,4 do
					local rot = a.rotation + rndsgn(random()*0.5)
					X = X + Imbir{
						position = {x = a.position.x, y = a.position.y},
						radius = 10,
						deltap = {x=0,y=0},
						velocity = {x=(1+random(2)) * cos(rot),
									y=(1+random(2)) * sin(rot)},
						rotation = rot,
						particle = true,
						countdown = 3,
					}
				end
				
				a.invincibility = 500
				a.position = {x=400,y=300}
				a.velocity = {x=0,y=0}
				
				X = X - LIFES[#LIFES]
				LIFES[#LIFES] = nil
				
				if #LIFES == 0 then
					SYSTEMS = GAMEOVER
					DRAW = DRAW_GAMEOVER
					X = X + Imbir{gameOver = true}
				else
					SYSTEMS = KILLED
					DRAW = DRAW_KILLED
				end
			end
		end
	end
	}
System{
	_name = 'applyDeltaP',
	
	'position',
	'deltap',
	
	Logic = function(a)
		a.position = { x = (a.position.x+a.deltap.x)%800,  y = (a.position.y+a.deltap.y)%600 }
		a.deltap = {x=0,y=0}
	end
	}
System{
	_name = 'applyDeltaR',
	
	'rotation',
	'deltar',
	
	Logic = function(a)
		a.rotation = a.rotation + a.deltar
		--a.deltap = {x=0,y=0}
	end
	}
	
System{
	_name = 'shipCooldown',
	
	'ship',
	
	Logic = function(a)
		a.invincibility = a.invincibility-1
		if a.invincibility < 300 then
			SYSTEMS = NORMAL
			DRAW = DRAW_NORMAL
		end
	end
	}
System{
	_name = 'bulletCountdown',
	
	'bullet',
	'countdown',
	
	Logic = function(a)
		a.countdown = a.countdown-1
		if a.countdown <= 0 then
			X = X-a
			a.parent.pellet = a.parent.pellet-1
		end
	end
	}

System{
	_name = 'changeCountdown',
	
	'ship',
	'win',
	'countdown',
	
	Logic = function(a)
		a.countdown = a.countdown-1
		
		if a.countdown == 100 then
			for i=1,12 do
				local rot = i/12 * 2*PI
				X = X + Imbir{
					position = {x = a.position.x, y = a.position.y},
					radius = 10,
					deltap = {x=0,y=0},
					velocity = {x=5 * cos(rot),
								y=5 * sin(rot)},
					rotation = rot,
					particle = true,
					countdown = 3,
				}
			end
			
			ship.position = {x = 0,y = 0}
			ship.velocity = {x=0,y=0}
		elseif a.countdown == 0 then
			SYSTEMS = NORMAL
			DRAW = DRAW_NORMAL
			Reset(SCORE,#LIFES+1)
		end
	end
	}
System{
	_name = 'particleCountdown',
	
	'particle',
	'countdown',
	
	Logic = function(a)
		a.countdown = a.countdown-1
		if a.countdown <= 0 then
			X = X-a
		end
	end
	}
	
System{
	_name = 'input',
	
	'input',
	
	Logic = function(a)
		if love.keyboard.isDown 'up' then
			a.velocity = {x = a.velocity.x + cos(a.rotation)*0.1, y = a.velocity.y + sin(a.rotation)*0.1}
		end
		if love.keyboard.isDown 'down' then
			a.velocity = {x = a.velocity.x - cos(a.rotation)*0.1, y = a.velocity.y - sin(a.rotation)*0.1}
		end
		if love.keyboard.isDown 'left' then
			a.rotation = a.rotation - PI*0.05
		end
		if love.keyboard.isDown 'right' then
			a.rotation = a.rotation + PI*0.05
		end
		
		a.velocity.x = clamp(-7,7,a.velocity.x)
		a.velocity.y = clamp(-7,7,a.velocity.y)
	end
	}
System{
	_name = 'drawGameOver',
	
	'gameOver',
	
	Logic = function(a)
		love.graphics.setColor(255,255,255)
		love.graphics.print('B U M M E R',280,230,0,3,3)
	end
	}
	
time = 0
function love.update(dt)
	local fps = 1/60
	time = time+dt	
	while time > fps do
		time = time-fps
		
		COL = {}
		--'applyCollisions',
		X(SYSTEMS)
	end
end

NORMAL = {'input','buildRockCollisionTable','checkForEmptyTable','checkForBulletCollisions','checkForShipCollisions','applyVelocity','applyDeltaP','applyDeltaR', 'bulletCountdown','particleCountdown'}
KILLED = {'shipCooldown','buildRockCollisionTable','checkForBulletCollisions','applyVelocity','applyDeltaP','applyDeltaR', 'bulletCountdown'}
WIN = {'changeCountdown','applyVelocity','applyDeltaP','applyDeltaR', 'bulletCountdown','particleCountdown'}
GAMEOVER = {}
SYSTEMS = NORMAL


DRAW_NORMAL = {'draw'}
DRAW_KILLED = {'draw'}
DRAW_GAMEOVER = {'drawGameOver'}
DRAW_WIN = {'draw'}
DRAW = DRAW_NORMAL

function love.draw()
	X(DRAW)	
	love.graphics.print(SCORE,360,3,0,2,2)
end




function love.keypressed(key)
	if key == 'escape' then
        love.event.push('quit') -- Quit the game.
    end 
end

function love.keyreleased(key)
		local a = ship

		if SYSTEMS==NORMAL and key == ' '  and  a.pellet < 3  then
			local P = Imbir{
				position = {x = a.position.x, y = a.position.y},
				radius = 10,
				deltap = {x=0,y=0},
				velocity = {x=10 * cos(a.rotation),
							y=10 * sin(a.rotation)},
				rotation = a.rotation,
				collidable = true,
				bullet = true,
				countdown = 100,
				parent = a
				}
			a.pellet = a.pellet+1
			X = X+P
		end
end
